import java.awt.*;
import java.awt.event.MouseEvent;
import javax.swing.*;

class A extends JPanel
{
   public static void main(String[] args)
   {
      A A = new A();

      JFrame f = new JFrame("Poker4k");
      f.add(A);
      f.setSize(640, 480);
      f.show();
      f.setDefaultCloseOperation(3);

      A.requestFocus();
   }

   private String[] e = new String[] { "highcard", "pair", "2 pairs", "3 of a kind", "straight", "flush", "full house", "4 of a kind", "straight flush", "royal flush" };



   private A()
   {
      enableEvents(48L);

      int[][] f = this.f;

      for (int i = 0; i < 52; i++)
      {
         f[i][0] = i % 4;
         f[i][1] = (i / 4) + 1;
      }

      f[52] = new int[] { 5, 18, 9, 0xC0C000, 0xC0C0C0, 0xC00000 };
      f[53] = new int[] { 160718880, 245653536, 331636768, 419717152, 509894688, 81131536, 131514384, 174482448, 579022880 };
   }

   private int[][] f = new int[60][13];



   public void paint(Graphics g)
   {
      Graphics2D q = (Graphics2D) g;

      q.setColor(new Color(0x663300));
      q.fillRect(0, 0, 640, 96);

      q.setColor(new Color(0x804000));
      q.fillRect(0, 96, 640, 384);

      q.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);

      q.setColor(new Color(0x905000));
      q.fillOval(200, 182, 240, 96);

      float x, y, z, p;

      for (int i = 0; i < 7; i++)
         q = c(q, 575 + i * 2, 384, i * 5, 54);

      int[][] f = this.f;
      int[] cd;

      int now = (int) (System.nanoTime() / 1000000L);

      for (int i = 0; i < 10; i++)
      {
         cd = f[i];
         x = cd[2];
         y = cd[3];
         z = cd[4];

         if (now <= cd[5])
         {
            p = 0.0F;
         }
         else if (now >= cd[9])
         {
            p = 1.0F;
            cd[2] = cd[6];
            cd[3] = cd[7];
            cd[4] = cd[8];
            cd[5] = now;
         }
         else
         {
            p = (float) (now - cd[5]) / (cd[9] - cd[5]);
            p = ((float) Math.sin((((1.0F - (1.0F - p) * (1.0F - p)) * 0.5F) - 0.25F) / 0.5F * 3.1415F) + 1.0F) * 0.5F;
         }

         x += p * (cd[6] - x);
         y += p * (cd[7] - y);
         z += p * (cd[8] - z);

         q = c(q, x, y, z, i);
      }

      for (int k = 0; k < 3; k++)
      {
         cd = f[52];

         for (int j = 0; j < cd[k]; j++)
         {
            for (int i = 0; i < 2; i++)
            {
               q.setColor(new Color(cd[3 + k] / (2 - i)));
               q.fillOval((j % 3) + 128 + (((k % 2) - 1) * 64) + k * 25, i * -3 + j * -4 + 384 + k * 24, 24, 8);
            }
         }
      }

      if (s == 9)
      {
         cd = f[57];

         for (int k = 0; k < 2; k++)
         {
            for (int i = 0; i < 5; i++)
            {
               f[58][i] = f[i + k * 5][0];
               f[59][i] = f[i + k * 5][1] - 1;
            }
            cd[k] = c(f[58], f[59]);
         }

         q.setColor(new Color(0x000000));
         q.fillRect(150, 50, 325, 90);
         q.setColor(new Color(0xFFC000));
         q.setFont(new Font("Helvetica", Font.PLAIN, 20));
         q.drawString("You:", 160, 75);
         q.drawString("Bill:", 160, 100);
         q.drawString(e[cd[0] >>> 16], 225, 75);
         q.drawString(e[cd[1] >>> 16], 225, 100);
         q.setColor(new Color(0x00C0FF));
         q.drawString(cd[0] > cd[1] ? "You won! You have a better hand." : "You lose!", 160, 125);
      }

      try
      {
         Thread.yield();
      }
      catch (Error e)
      {
         //
      }

      if (w && ((System.nanoTime() / 1000000L) - A) > v)
         processEvent(null);

      repaint();
   }



   private final Graphics2D c(Graphics2D q, float x, float y, float z, int i)
   {
      Graphics2D q1 = (Graphics2D) q.create(), q2 = null;
      int[] f = this.f[i];
      int j, t, value = f[1];
      float p2, p3;

      q.translate(x, y);
      {
         p2 = x / 640 - 0.5F;
         p3 = y / 480;
         q.translate((160 - x * 0.5F) * (1.0F - p3), -y * 0.5F);

         p3 = p3 * 0.5F + 0.5F;
         q.scale(p3, p3);

         p2 *= ((1 - f[10]) * 2 - 1) * 0.25F;
         q.shear(p2, -p2);

         if (f[10] != 1)
         {
            q.translate(0.0F, 24.0F);
            q.scale(1.0F, 0.5F);
            q.shear(2.0F * p2, p2);
         }
         else
         {
            q2 = q;
            q = (Graphics2D) q.create();

            q.scale(1.0F, 0.5F);
            q.translate(16.0F, 48.0F - z);
            q.shear(-0.25F, 0.0F);
         }

         q.setColor(new Color(0, 0, 0, 64));
         q.fillRoundRect(-30, -46, 64, 96, 8, 8);

         if (f[10] == 1)
            q = q2;

         q.translate(0, -z);

         q.setColor(new Color(f[10] == 1 ? 0xFFFFF0 : 0xEEEEE0));
         q.fillRoundRect(-32, -48, 64, 96, 8, 8);

         q.setColor(new Color(0x404040));
         q.drawRoundRect(-32, -48, 64, 96, 8, 8);

         if (f[11] == 1)
         {
            t = f[0];

            String suit = String.valueOf(new char[] { '\u2660', '\u2663', '\u2665', '\u2666' }[t]);

            if (t > 1)
               q.setColor(new Color(0xC00000));

            if (value <= 10)
            {
               x = (768154053244724416L >> ((value - 1) * 3)) & 0x07;
               y = (768154053244724416L >> ((value + 9) * 3)) & 0x07;

               q.setFont(new Font("Helvetica", 0, 18));

               for (j = 0; j < x; j++)
                  for (t = 0; t < (value == 3 ? 1 : 2); t++)
                     q.drawString(suit, t * -28 + (value == 3 ? -7 : 7), (53.0F / (x - 1.0F)) * j - 19);

               for (j = 0; j < 3; j++)
                  if (((int) y & (1 << j)) != 0)
                     q.drawString(suit, -7, 13 * (j + 1) - 19);
            }

            for (j = 0; j < 2; j++)
            {
               q.setFont(new Font("Helvetica", 0, 8));
               q.drawString(value == 10 ? "10" : String.valueOf("xA23456789*JQK".charAt(value)), j * 49 - 26, j * 80 - 36);

               q.setFont(new Font("Helvetica", 0, 10));
               q.drawString(suit, j * 48 - 27, j * 63 - 27);
            }
         }
      }

      return q1;
   }



   private final void c(int to)
   {
      int from = (int) (Math.random() * 42) + 10;

      int[] t = f[to];
      f[to] = f[from];
      f[from] = t;

      f[to][2] = f[to][6] = f[from][2];
      f[to][3] = f[to][7] = f[from][3];
      f[to][4] = f[to][8] = f[from][4];
   }



   private final int c(int[] s, int[] v)
   {
      int[] w = new int[11], u = new int[4], t = new int[13];
      int i, j = 0, k = 0, m;

      for (i = 0; i < 5; i++)
      {
         u[s[i]]++;
         t[v[i]]++;
      }

      for (i = 0; i < 13; i++)
      {
         m = i + 1;

         if (i < 4 && u[i] == 5 && m > w[4])
            w[4] = m;

         if (m > w[10])
            w[10] = m;

         if (t[i] != 1)
            k = 0;
         else if ((++k) == 5)
            w[3] = m;

         if (t[i] == 2)
         {
            w[j] = m;
            j = 9;
         }

         if (t[i] == 3)
            w[2] = m;

         if (t[i] == 4)
            w[6] = m;
      }

      if (w[9] != 0 && w[0] != 0)
         w[1] = (w[9] << 8) | w[0];

      if (w[2] != 0 && w[0] != 0)
         w[5] = (w[2] << 8) | w[0];

      if (w[3] != 0 && w[4] != 0)
         w[7] = w[3] << 8;

      if (w[7] != 0 && w[3] != 0)
         w[8] = 1 << 8;

      for (i = 8; i >= 0; i--)
      {
         k = w[i];

         if (k < 0xFF)
            k <<= 8;

         if (k > 0.0F)
            return ((i + 1) << 16) | k;
      }

      return w[10];
   }



   private final float c(int[] s, int[] v, int[] k, int o, float c)
   {
      int[] hs = new int[5];
      int[] hv = new int[5];

      for (int i = 0; i < 5; i++)
      {
         hs[i] = s[i];
         hv[i] = v[i];
      }

      int wins = 0, winScore = 0, totalScore = 0, i, h;
      float n = 0.0F, score;

      l: for (i = 0; i < 52; i++)
      {
         hs[k[o]] = i / 13;
         hv[k[o]] = i % 13;

         if (o == k.length - 1)
         {
            for (h = 0; h < 5; h++)
               if ((i / 13) == s[h] && (i % 13) == v[h])
                  continue l;

            score = c(hs, hv);

            totalScore += score;

            if (score > c)
            {
               winScore += score;
               wins++;
            }
         }
         else
         {
            n += c(hs, hv, k, o + 1, c);
         }
      }

      return ((o == k.length - 1) ? (wins * (winScore / totalScore)) : n) / 52.0F;
   }



   private final int[] A(int[] s, int[] v)
   {
      float t = c(s, v), g = 0.0F, c;
      int[] r = new int[0];

      for (int z = 0; z < 3; z++)
      {
         for (int i = 0; i < (z >= 3 ? 5 : 1); i++)
         {
            for (int j = i; j < (z >= 2 ? 5 : 1); j++)
            {
               for (int k = j; k < (z >= 1 ? 5 : 1); k++)
               {
                  int[] w = new int[z + 1];

                  if (z >= 0)
                     w[0] = k;
                  if (z >= 1)
                     w[1] = j;
                  if (z >= 2)
                     w[2] = i;

                  c = c(s, v, w, 0, t);

                  if (c > g)
                  {
                     g = c;
                     r = w;
                  }
               }
            }
         }
      }

      return r;
   }

   /**
    * KE3S
    */

   int s = 1;



   public final void processEvent(AWTEvent a)
   {
      int[] cd = this.f[53], l = null;
      int id = -1, now = (int) (System.nanoTime() / 1000000L), hs = 255;

      if (a != null)
      {
         if ((id = a.getID()) == 503 || id == 500)
         {
            MouseEvent evt = (MouseEvent) a;
            int x = evt.getX(), y = evt.getY();

            for (int i = 0; i < 9; i++)
            {
               int fi = cd[i];
               int x0 = (fi >> 20) & 1023;
               int y0 = (fi >> 10) & 1023;
               int r0 = (fi >> 0) & 1023;

               if (x > x0 - r0 && x < x0 + r0 && y > y0 - r0 && y < y0 + r0)
                  hs = i;
            }

            setCursor(Cursor.getPredefinedCursor(hs == 255 ? 0 : 12));
         }

         if (id != 500)
            return;
      }
      else
         w = false;

      int s = this.s, next = 0;

      for (int ci = 0; ci < 10; ci++)
      {
         cd = this.f[ci];

         boolean time = false;

         if (s == 1)
         {
            c(ci);
            cd = this.f[ci];

            cd[2] = 579 + ci * 2;
            cd[3] = 375;
            cd[4] = ci << 2;

            cd[6] = 174 + (ci % 5) * 72;
            cd[7] = ci < 5 ? 608 : 256;
            cd[8] = 0;

            cd[10] = cd[11] = cd[12] = 0;

            time = true;
            next = 30;
         }
         if (s == 2)
         {
            cd[10] = 1;
            cd[11] = ci < 5 ? 1 : 0;

            next = 8;
         }
         if (s == 5)
         {
            if (cd[12] == 1)
            {
               cd[6] = 579 + ci * 2;
               cd[7] = 375;
               cd[8] = ci * 4;

               cd[10] = cd[11] = 0;

               time = true;
            }

            next = 20;
         }
         if (s == 6)
         {
            if (cd[12] == 1)
            {
               c(ci);
               cd = this.f[ci];

               cd[6] = 174 + (ci % 5) * 72;
               cd[7] = (1 - ci / 5) * 352 + 256;
               cd[8] = 0;

               cd[10] = cd[11] = 0;

               time = true;
            }

            next = 25;
         }
         if (s == 7)
         {
            cd[11] = 1 - ci / 5;
            cd[10] = 1;
         }
         if (s == 8)
         {
            cd[7] = (1 - ci / 5) * 200 + 450;

            cd[11] = 1;
            cd[10] = ci / 5;
            cd[12] = 0;

            time = true;
         }

         if (time)
         {
            cd[5] = now + (10 - ci) * (next + 5) * 5;
            cd[9] = cd[5] + 500;
         }
      }

      if (s == 3)
      {
         int[][] f = this.f;
         int[] t0 = new int[5];
         int[] s0 = new int[5];

         for (int k = 0; k < 5; k++)
         {
            t0[k] = f[k + 5][0];
            s0[k] = f[k + 5][1] - 1;
         }

         setCursor(Cursor.getPredefinedCursor(3));
         l = A(t0, s0);
         setCursor(Cursor.getPredefinedCursor(0));

         for (int k = 0; k < l.length; k++)
         {
            int m = 5 + l[k];
            c(m);
            cd = f[m];

            cd[10] = 1;
            cd[11] = 0;
            cd[12] = 1;

            cd[8] = cd[12] << 4;
            cd[5] = now + m * 50;
            cd[9] = cd[5] + 750;
         }

         s = 4;

         next = 10;
      }

      if (s == 4)
      {
         if (hs < 5)
         {
            cd = this.f[hs];

            cd[11] = 1;
            cd[12] = 1 - cd[12];

            cd[8] = cd[12] << 4;
            cd[5] = now + hs * 50;
            cd[9] = cd[5] + 750;
         }

         if (hs == 8)
            next = 8;
      }

      if (next != 0)
      {
         A = now;
         w = true;
         v = next * 100;
      }

      if (s != 4 || hs == 8)
         s++;

      if (s > 9)
         s = 1;

      this.s = s;
   }

   private int A = -1, v = 0;
   private boolean w = false;
}